<?php
require_once('lib/exif.inc');

function getImageExifView($target, $mother){
	global $owner, $suri, $configVal;
	requireComponent('Tattertools.Function.misc');
	$data = misc::fetchConfigVal($configVal);
	$data['sImage'] = (is_null($data['sImage']))?1:$data['sImage'];
	$data['exifwidth'] = (is_null($data['exifwidth']))?2:$data['exifwidth'];
	if(getAttachCheck_Exif(misc::getFileExtension($mother)) &&  $suri['directive']!="/rss" && $data['sImage']){
		$attachPath = ROOT."/attach/{$owner}/".basename($mother);
		$contentWidth =	misc::getContentWidth();
		if (preg_match('/width="([1-9][0-9]*)"/i', $target, $temp)) {
			if($data['exifwidth'] == 2){
				$tempWidth = ($temp[1] >= $contentWidth)?"":"width:".$temp[1]."px;";
			}else{
				$tempWidth = "";
			}
		}

		switch($data['exifalign']){
			case 1:		$data['exifalign'] = "left";	break;
			case 2:		$data['exifalign'] = "center";	break;
			case 3:		$data['exifalign'] = "right";	break;
			default:	$data['exifalign'] = "center";
		}
		if(getExifImage($attachPath , 0)){
//			$target  = preg_replace("@<img(.*)\/>@iU" , '<img$1longDesc="ExifImage"/>', $target);
			$target .= "<div align=\"{$data['exifalign']}\"><div class=\"ExifView\" style=\"{$tempWidth}\">";
			$target .= getExifImage($attachPath , 0);
			$target .= "</div></div>";
		}
	}

	return $target;
}

function getImageFreeExifView($target, $mother){
	global $owner, $suri, $configVal;
	requireComponent('Tattertools.Function.misc');
	$data = misc::fetchConfigVal($configVal);
	$data['fImage'] = (is_null($data['fImage']))?1:$data['fImage'];
	$data['exifwidth'] = (is_null($data['exifwidth']))?2:$data['exifwidth'];
	$tempImages = preg_match_all('@<img src="(.*)\" width="(.*)\" height="(.*)\"(.*)\/>@iU', $target, $temp);
	if($tempImages && $data['fImage']){
		for ($i=0; $i<$tempImages; $i++){
			if(!trim($temp[4][$i])){
				if(getAttachCheck_Exif(misc::getFileExtension($temp[1][$i])) &&  $suri['directive']!="/rss"){
					$attachPath = ROOT."/attach/{$owner}/".basename($temp[1][$i]);
					$contentWidth =	misc::getContentWidth();
					if($data['exifwidth'] == 2){
						$tempWidth = ($temp[2][$i] >= $contentWidth)?"":"width:".$temp[2][$i]."px;";
					}else{
						$tempWidth = "";
					}
					switch($data['exifalign']){
						case 1:		$data['exifalign'] = "left";	break;
						case 2:		$data['exifalign'] = "center";	break;
						case 3:		$data['exifalign'] = "right";	break;
						default:	$data['exifalign'] = "center";
					}
					if(getExifImage($attachPath , 0)){
						$exifInfo = "<div>";
						$exifInfo .= $temp[0][$i]."<div class=\"ExifView\" style=\"{$tempWidth}\">";
						$exifInfo .= getExifImage($attachPath , 0);
						$exifInfo .= "</div></div>";
						$target = str_replace($temp[0][$i], $exifInfo, $target);
					}
				}
			}
		}
	}
	return $target;
}

function getExifImage($filePath,$verbose){
	global  $configVal;
	requireComponent('Tattertools.Function.misc');
	$data = misc::fetchConfigVal($configVal);
	if(is_null($data)){
		for($i=0; $i <= 14; $i++){
			$data['ex'.$i] = 1;
		}
	}

	$exifResult = read_exif_data_raw($filePath, 0);

	if(isset($exifResult)){
		$exifInfo = array();
		$spacer = "<span class=\"exifSP\"> | </span>";
		if($exifResult['SubIFD']['ExposureBiasValue']){
			$evtmp = split(" ", $exifResult['SubIFD']['ExposureBiasValue']);
			$exifResult['SubIFD']['ExposureBiasValue'] = ((round($evtmp[0],2) > 0)? '+': '').round($evtmp[0],2).$evtmp[1];
		}
		if(!is_null($exifResult['SubIFD']['WhiteBalance'])){
			$exifResult['SubIFD']['WhiteBalance'] = ($exifResult['SubIFD']['WhiteBalance']==0)?"Auto W/B":"Manual W/B";
		}
		if($exifResult['SubIFD']['FNumber']){
			$fntmp = split(" ", $exifResult['SubIFD']['FNumber']);
			$exifResult['SubIFD']['FNumber'] = $fntmp[0].round($fntmp[1],2);
		}
		if($exifResult['IFD0']['Make']						&& $data['ex1'])	array_push($exifInfo, getDecode($exifResult['IFD0']['Make']));										// 1.제조사
		if($exifResult['IFD0']['Model']						&& $data['ex2'])	array_push($exifInfo, getDecode($exifResult['IFD0']['Model']));										// 2.모델
		if($exifResult['SubIFD']['ExposureProgram']			&& $data['ex3'])	array_push($exifInfo, getDecode($exifResult['SubIFD']['ExposureProgram']));							// 3.촬영모드
		if($exifResult['SubIFD']['MeteringMode']			&& $data['ex4'])	array_push($exifInfo, getDecode($exifResult['SubIFD']['MeteringMode']));							// 4.측광모드
		if($exifResult['SubIFD']['WhiteBalance']			&& $data['ex5'])	array_push($exifInfo, $exifResult['SubIFD']['WhiteBalance']);										// 5.화이트밸런스
		if($exifResult['SubIFD']['ExposureTime']			&& $data['ex6'])	array_push($exifInfo, getReduceExif($exifResult['SubIFD']['ExposureTime']).'sec');					// 6.셔터속도
		if($exifResult['SubIFD']['FNumber']					&& $data['ex7'])	array_push($exifInfo, strtoupper($exifResult['SubIFD']['FNumber']));								// 7.조리개값
		if($exifResult['SubIFD']['MaxApertureValue']		&& $data['ex8'])	array_push($exifInfo, strtoupper(str_replace(" ","",$exifResult['SubIFD']['MaxApertureValue'])));	// 8.최대 조리개값
		if($exifResult['SubIFD']['ExposureBiasValue']		&& $data['ex9'])	array_push($exifInfo, $exifResult['SubIFD']['ExposureBiasValue']);									// 9.노출보정
		if($exifResult['SubIFD']['FocalLength']				&& $data['ex10'])	array_push($exifInfo, str_replace(" ","",$exifResult['SubIFD']['FocalLength']));					// 10.초점거리
		if($exifResult['SubIFD']['FocalLengthIn35mmFilm']	&& $data['ex11'])	array_push($exifInfo, '35mm equiv '.$exifResult['SubIFD']['FocalLengthIn35mmFilm'].'mm');			// 11.35mm 초점거리
		if($exifResult['SubIFD']['ISOSpeedRatings']			&& $data['ex12'])	array_push($exifInfo, 'ISO-'.$exifResult['SubIFD']['ISOSpeedRatings']);								// 12.ISO값
		if($exifResult['SubIFD']['Flash']					&& $data['ex13'])	array_push($exifInfo, $exifResult['SubIFD']['Flash']);												// 13.플래쉬사용
		if($exifResult['SubIFD']['DateTimedigitized']		&& $data['ex14'])	array_push($exifInfo, getDecode($exifResult['SubIFD']['DateTimedigitized']));						// 14.촬영시각

		$exifValue = ($exifInfo)?"  <span>" . implode("</span>{$spacer}<span>", $exifInfo) . "</span>":NULL;
	}
	return $exifValue;
}

function getDecode($str){
	$str = str_replace(array("<",">"), array("",""), $str);
	$str = utf8_decode($str);
	$str = trim($str);
	return $str;
}

function getImageExifViewStyle($target){
	global $configVal;
	requireComponent('Tattertools.Function.misc');
	$data = misc::fetchConfigVal($configVal);
	if(is_null($data)){
		$data['exifmargin']	= "5px 0px 0px 0px";
		$data['exifpadding']= "0px 0px 0px 0px";
		$data['exiffont']	= "tahoma";
		$data['exifsize']	= "7pt";
		$data['exifcolor']	= "#777777";
		$data['exifalign']	= 2;
	}
	switch($data['exifalign']){
		case 1:		$data['exifalign'] = "left";	break;
		case 2:		$data['exifalign'] = "center";	break;
		case 3:		$data['exifalign'] = "right";	break;
		default:	$data['exifalign'] = "center";
	}
	ob_start();
?>
<style type="text/css">
	/* Exif Data CSS Setting */
	.ExifView {margin:<?php echo $data['exifmargin'];?>;padding:<?php echo $data['exifpadding'];?>; font:<?php echo $data['exifsize'];?> <?php echo $data['exiffont'];?>;color:<?php echo $data['exifcolor'];?>;text-align:<?php echo $data['exifalign'];?>;}
	.ExifView span {display:inline !important;white-space:normal !important;}
	.ExifView .exifSP {font:7pt Arial;color:#ccc;margin:0px 0px 0px 0px;}
</style>
<?php
	$target .= ob_get_contents();
	ob_end_clean();
	return $target;
}

function getAttachCheck_Exif($ext){
	$attachArray = array('jpg','jpeg','png');
	foreach ($attachArray as $item){
		if($item == $ext) return true;
	}
}

function getReduceExif($exifvalue){
	$vals = split("/",$exifvalue);
	if(count($vals) == 2){
		$exposure = round($vals[0]/$vals[1],2);
		if($exposure < 1) $exposure = "1/".round($vals[1]/$vals[0],0);
	}else{
		$exposure = round($vals[0]/$vals[1], 2)."s";
	}
	return $exposure;
}

function ImageExifViewDataSet($DATA){
	requireComponent('Tattertools.Function.misc');
	$cfg = misc::fetchConfigVal($DATA);
	if(!$cfg['sImage'] && !$cfg['fImage']) return "::선택 오류::\n\n사진 EXIF 적용 범위는 적어도 하나이상 선택하셔야 합니다.   ";
	if(!$cfg['exifwidth']) return "::선택 오류::\n\n사진 EXIF 정보의 가로크기 표시 방법을 선택하셔야 합니다.   ";
	return true;
}
?>